//[module]	DMACMAN
//[processor]	IOP
//[type]	ELF-IRX
//[size]	14069(0x36F5)
//[bios]	T10000(0x28380-0x2BA80)
//[iopboot]	06
//[name]	dmacman
//[version]	0x101
//[memory map]	0xBF801080,0xBF801084,0xBF801088,
//		0xBF801090,0xBF801094,0xBF801098,
//		0xBF8010A0,0xBF8010A4,0xBF8010A8,
//		0xBF8010B0,0xBF8010B4,0xBF8010B8,
//		0xBF8010C0,0xBF8010C4,0xBF8010C8, 0xBF8010CC,
//		0xBF8010D0,0xBF8010D4,0xBF8010D8,
//		0xBF8010E0,0xBF8010E4,0xBF8010E8,
//  
//		0xBF8010F0,0xBF8010F4,
//
//		0xBF801500,0xBF801504,0xBF801508,
//		0xBF801510,0xBF801514,0xBF801518,
//		0xBF801520,0xBF801524,0xBF801528, 0xBF80152C,
//		0xBF801530,0xBF801534,0xBF801538,
//		0xBF801540,0xBF801544,0xBF801548,
//		0xBF801550,0xBF801554,0xBF801558,
//
//		0xBF801560,0xBF801564,0xBF801568,
//
//		0xBF801570, 0xBF801574,0xBF801578,0xBF80157C,
//		0xBF8015F0
//[handlers]	-
//[entry point]	start, export_stub
//[made by]	[RO]man

#include "..\include\sysmem.h"		//(0x101,Kprintf)
#include "..\include\loadcore.h"	//(0x101,RegisterLibraryEntries)
#include "..\include\intrman.h"		//(0x102,CpuSuspendIntr,CpuResumeIntr)

#define DMAch_CONTINUED	0x01000000

func reg_set[]={_setBF801080, _setBF801090, _setBF8010A0, _setBF8010B0,
		_setBF8010C0, _setBF8010D0, _setBF8010E0,
		_setBF801500, _setBF801510, _setBF801520,
		_setBF801530, _setBF801540, _setBF801550,	0
};

func reg_get[]={_getBF801080, _getBF801090, _getBF8010A0, _getBF8010B0,
		_getBF8010C0, _getBF8010D0, _getBF8010E0,
		_getBF801500, _getBF801510, _getBF801520,
		_getBF801530, _getBF801540, _getBF801550,	0
};

func reg_set_4[]={_setBF801084, _setBF801094, _setBF8010A4, _setBF8010B4,
		  _setBF8010C4, _setBF8010D4, _setBF8010E4,
		  _setBF801504, _setBF801514, _setBF801524,
		  _setBF801534, _setBF801544, _setBF801554,	0
};

func reg_get_4[]={_getBF801084, _getBF801094, _getBF8010A4, _getBF8010B4,
		  _getBF8010C4, _getBF8010D4, _getBF8010E4,
		  _getBF801504, _getBF801514, _getBF801524,
		  _getBF801534, _getBF801544, _getBF801554,	0
};

func reg_set_8[]={_setBF801088, _setBF801098, _setBF8010A8, _setBF8010B8,
		  _setBF8010C8, _setBF8010D8, _setBF8010E8,
		  _setBF801508, _setBF801518, _setBF801528,
		  _setBF801538, _setBF801548, _setBF801558,	0
};

func reg_get_8[]={_getBF801088, _getBF801098, _getBF8010A8, _getBF8010B8,
		  _getBF8010C8, _getBF8010D8, _getBF8010E8,
		  _getBF801508, _getBF801518, _getBF801528,
		  _getBF801538, _getBF801548, _getBF801558,	0
};

///////////////////////////////////////////////////////////////////////
void dmacman_call4(unsigned int ch, int value){
	if (ch<13)
		reg_set[ch](ch, value);	//function call
}

///////////////////////////////////////////////////////////////////////
void _setBF801080(unsigned int ch, int value){
	*(int*)0xBF801080=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF801090(unsigned int ch, int value){
	*(int*)0xBF801090=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF8010A0(unsigned int ch, int value){
	*(int*)0xBF8010A0=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF8010B0(unsigned int ch, int value){
	*(int*)0xBF8010B0=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF8010C0(unsigned int ch, int value){
	*(int*)0xBF8010C0=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF8010D0(unsigned int ch, int value){
	*(int*)0xBF8010D0=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF8010E0(unsigned int ch, int value){
	*(int*)0xBF8010E0=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF801500(unsigned int ch, int value){
	*(int*)0xBF801500=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF801510(unsigned int ch, int value){
	*(int*)0xBF801510=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF801520(unsigned int ch, int value){
	*(int*)0xBF801520=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF801530(unsigned int ch, int value){
	*(int*)0xBF801530=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF801540(unsigned int ch, int value){
	*(int*)0xBF801540=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF801550(unsigned int ch, int value){
	*(int*)0xBF801550=value;
}

///////////////////////////////////////////////////////////////////////
int  dmacman_call5(unsigned int ch){
	if (ch<13)
		return reg_get[ch](ch);	//function call
	return 0;
}

///////////////////////////////////////////////////////////////////////
int  _getBF801080(unsigned int ch){
	return *(int*)0xBF801080;
}

///////////////////////////////////////////////////////////////////////
int  _getBF801090(unsigned int ch){
	return *(int*)0xBF801090;
}

///////////////////////////////////////////////////////////////////////
int  _getBF8010A0(unsigned int ch){
	return *(int*)0xBF8010A0;
}

///////////////////////////////////////////////////////////////////////
int  _getBF8010B0(unsigned int ch){
	return *(int*)0xBF8010B0;
}

///////////////////////////////////////////////////////////////////////
int  _getBF8010C0(unsigned int ch){
	return *(int*)0xBF8010C0;
}

///////////////////////////////////////////////////////////////////////
int  _getBF8010D0(unsigned int ch){
	return *(int*)0xBF8010D0;
}

///////////////////////////////////////////////////////////////////////
int  _getBF8010E0(unsigned int ch){
	return *(int*)0xBF8010E0;
}

///////////////////////////////////////////////////////////////////////
int  _getBF801500(unsigned int ch){
	return *(int*)0xBF801500;
}

///////////////////////////////////////////////////////////////////////
int  _getBF801510(unsigned int ch){
	return *(int*)0xBF801510;
}

///////////////////////////////////////////////////////////////////////
int  _getBF801520(unsigned int ch){
	return *(int*)0xBF801520;
}

///////////////////////////////////////////////////////////////////////
int  _getBF801530(unsigned int ch){
	return *(int*)0xBF801530;
}

///////////////////////////////////////////////////////////////////////
int  _getBF801540(unsigned int ch){
	return *(int*)0xBF801540;
}

///////////////////////////////////////////////////////////////////////
int  _getBF801550(unsigned int ch){
	return *(int*)0xBF801550;
}

///////////////////////////////////////////////////////////////////////
void dmacman_call6(unsigned int ch, int value){
	if (ch<13)
		reg_set_4[ch](ch, value);	//function call
}

///////////////////////////////////////////////////////////////////////
void _setBF801084(unsigned int ch, int value){
	*(int*)0xBF801084=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF801094(unsigned int ch, int value){
	*(int*)0xBF801094=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF8010A4(unsigned int ch, int value){
	*(int*)0xBF8010A4=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF8010B4(unsigned int ch, int value){
	*(int*)0xBF8010B4=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF8010C4(unsigned int ch, int value){
	*(int*)0xBF8010C4=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF8010D4(unsigned int ch, int value){
	*(int*)0xBF8010D4=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF8010E4(unsigned int ch, int value){
	*(int*)0xBF8010E4=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF801504(unsigned int ch, int value){
	*(int*)0xBF801504=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF801514(unsigned int ch, int value){
	*(int*)0xBF801514=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF801524(unsigned int ch, int value){
	*(int*)0xBF801524=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF801534(unsigned int ch, int value){
	*(int*)0xBF801534=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF801544(unsigned int ch, int value){
	*(int*)0xBF801544=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF801554(unsigned int ch, int value){
	*(int*)0xBF801554=value;
}

///////////////////////////////////////////////////////////////////////
int  dmacman_call7(unsigned int ch){
	if (ch<13)
		return reg_get_4[ch](ch);	//function call
	return 0;
}

///////////////////////////////////////////////////////////////////////
int  _getBF801084(unsigned int ch){
	return *(int*)0xBF801084;
}

///////////////////////////////////////////////////////////////////////
int  _getBF801094(unsigned int ch){
	return *(int*)0xBF801094;
}

///////////////////////////////////////////////////////////////////////
int  _getBF8010A4(unsigned int ch){
	return *(int*)0xBF8010A4;
}

///////////////////////////////////////////////////////////////////////
int  _getBF8010B4(unsigned int ch){
	return *(int*)0xBF8010B4;
}

///////////////////////////////////////////////////////////////////////
int  _getBF8010C4(unsigned int ch){
	return *(int*)0xBF8010C4;
}

///////////////////////////////////////////////////////////////////////
int  _getBF8010D4(unsigned int ch){
	return *(int*)0xBF8010D4;
}

///////////////////////////////////////////////////////////////////////
int  _getBF8010E4(unsigned int ch){
	return *(int*)0xBF8010E4;
}

///////////////////////////////////////////////////////////////////////
int  _getBF801504(unsigned int ch){
	return *(int*)0xBF801504;
}

///////////////////////////////////////////////////////////////////////
int  _getBF801514(unsigned int ch){
	return *(int*)0xBF801514;
}

///////////////////////////////////////////////////////////////////////
int  _getBF801524(unsigned int ch){
	return *(int*)0xBF801524;
}

///////////////////////////////////////////////////////////////////////
int  _getBF801534(unsigned int ch){
	return *(int*)0xBF801534;
}

///////////////////////////////////////////////////////////////////////
int  _getBF801544(unsigned int ch){
	return *(int*)0xBF801544;
}

///////////////////////////////////////////////////////////////////////
int  _getBF801554(unsigned int ch){
	return *(int*)0xBF801554;
}

///////////////////////////////////////////////////////////////////////
void dmacman_call8(unsigned int ch, int value){
	if (ch<13)
		reg_set_8[ch](ch, value);	//function call
}

///////////////////////////////////////////////////////////////////////
void _setBF801088(unsigned int ch, int value){
	*(int*)0xBF801088=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF801098(unsigned int ch, int value){
	*(int*)0xBF801098=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF8010A8(unsigned int ch, int value){
	*(int*)0xBF8010A8=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF8010B8(unsigned int ch, int value){
	*(int*)0xBF8010B8=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF8010C8(unsigned int ch, int value){
	*(int*)0xBF8010C8=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF8010D8(unsigned int ch, int value){
	*(int*)0xBF8010D8=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF8010E8(unsigned int ch, int value){
	*(int*)0xBF8010E8=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF801508(unsigned int ch, int value){
	*(int*)0xBF801508=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF801518(unsigned int ch, int value){
	*(int*)0xBF801518=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF801528(unsigned int ch, int value){
	*(int*)0xBF801528=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF801538(unsigned int ch, int value){
	*(int*)0xBF801538=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF801548(unsigned int ch, int value){
	*(int*)0xBF801548=value;
}

///////////////////////////////////////////////////////////////////////
void _setBF801558(unsigned int ch, int value){
	*(int*)0xBF801558=value;
}

///////////////////////////////////////////////////////////////////////
int  dmacman_call9(unsigned int ch){
	if (ch<13)
		return reg_get_8[ch](ch);	//function call
	return 0;
}

///////////////////////////////////////////////////////////////////////
int  _getBF801088(unsigned int ch){
	return *(int*)0xBF801088;
}

///////////////////////////////////////////////////////////////////////
int  _getBF801098(unsigned int ch){
	return *(int*)0xBF801098;
}

///////////////////////////////////////////////////////////////////////
int  _getBF8010A8(unsigned int ch){
	return *(int*)0xBF8010A8;
}

///////////////////////////////////////////////////////////////////////
int  _getBF8010B8(unsigned int ch){
	return *(int*)0xBF8010B8;
}

///////////////////////////////////////////////////////////////////////
int  _getBF8010C8(unsigned int ch){
	return *(int*)0xBF8010C8;
}

///////////////////////////////////////////////////////////////////////
int  _getBF8010D8(unsigned int ch){
	return *(int*)0xBF8010D8;
}

///////////////////////////////////////////////////////////////////////
int  _getBF8010E8(unsigned int ch){
	return *(int*)0xBF8010E8;
}

///////////////////////////////////////////////////////////////////////
int  _getBF801508(unsigned int ch){
	return *(int*)0xBF801508;
}

///////////////////////////////////////////////////////////////////////
int  _getBF801518(unsigned int ch){
	return *(int*)0xBF801518;
}

///////////////////////////////////////////////////////////////////////
int  _getBF801528(unsigned int ch){
	return *(int*)0xBF801528;
}

///////////////////////////////////////////////////////////////////////
int  _getBF801538(unsigned int ch){
	return *(int*)0xBF801538;
}

///////////////////////////////////////////////////////////////////////
int  _getBF801548(unsigned int ch){
	return *(int*)0xBF801548;
}

///////////////////////////////////////////////////////////////////////
int  _getBF801558(unsigned int ch){
	return *(int*)0xBF801558;
}

///////////////////////////////////////////////////////////////////////
void dmacman_call10(unsigned int code, int value){
	if (code==4)
		*(int*)0xBF8010CC=value;	else
	if (code==9)
		*(int*)0xBF80152C=value;
}

///////////////////////////////////////////////////////////////////////
int  dmacman_call11(unsigned int code){
	if (code==4)
		return *(int*)0xBF8010CC;
	if (code==9)
		return *(int*)0xBF80152C;
	return 0;
}

///////////////////////////////////////////////////////////////////////
void dmacman_call12(unsigned int code, int value){
	if (code==4)
		*(int*)0xBF801568=value;	else
	if (code==9)
		*(int*)0xBF801560=value;	else
	if (code==10)
		*(int*)0xBF801564=value;
}

///////////////////////////////////////////////////////////////////////
int  dmacman_call13(unsigned int code){
	if (code==4)
		return *(int*)0xBF801568;
	if (code==9)
		return *(int*)0xBF801560;
	if (code==10)
		return *(int*)0xBF801564;
	return 0;
}

///////////////////////////////////////////////////////////////////////
void dmacman_call14_setBF8010F0(int value){
	*(int*)0xBF8010F0=value;
}

///////////////////////////////////////////////////////////////////////
int  dmacman_call15_getBF8010F0(){
	return *(int*)0xBF8010F0;
}

///////////////////////////////////////////////////////////////////////
void dmacman_call16_setBF801570(int value){
	*(int*)0xBF801570=value;
}

///////////////////////////////////////////////////////////////////////
int  dmacman_call17_getBF801570(){
	return *(int*)0xBF801570;
}

///////////////////////////////////////////////////////////////////////
void dmacman_call18_setBF8015F0(int value){
	*(int*)0xBF8015F0=value;
}

///////////////////////////////////////////////////////////////////////
int  dmacman_call19_getBF8015F0(){
	return *(int*)0xBF8015F0;
}

///////////////////////////////////////////////////////////////////////
void dmacman_call20_setBF8010F4(int value){
	*(int*)0xBF8010F4=value;
}

///////////////////////////////////////////////////////////////////////
int  dmacman_call21_getBF8010F4(){
	return *(int*)0xBF8010F4;
}

///////////////////////////////////////////////////////////////////////
void dmacman_call22_setBF801574(int value){
	*(int*)0xBF801574=value;
}

///////////////////////////////////////////////////////////////////////
int  dmacman_call23_getBF801574(){
	return *(int*)0xBF801574;
}

///////////////////////////////////////////////////////////////////////
void dmacman_call24_setBF80157C(int value){
	*(int*)0xBF80157C=value;
}

///////////////////////////////////////////////////////////////////////
int  dmacman_call25_getBF80157C(){
	return *(int*)0xBF80157C;
}

///////////////////////////////////////////////////////////////////////
void dmacman_call26_setBF801578(int value){
	*(int*)0xBF801578=value;
}

///////////////////////////////////////////////////////////////////////
int  dmacman_call27_getBF801578(){
	return *(int*)0xBF801578;
}

// Note: it is not a true extern variable
// it only allows me to use export_stub reference in 'start' function
extern struct export export_stub;

//////////////////////////////entrypoint///////////////////////////////
int  start(){
     int x;
     register int ch;

	if (RegisterLibraryEntries(&export_stub))		//loadcore
		return 1;

	CpuSuspendIntr(&x);					//intrman

	dmacman_call14_setBF8010F0(0x07777777);
	dmacman_call16_setBF801570(0x07777777);
	dmacman_call18_setBF8015F0(0x00000777);
	for (ch=0; ch<13; ch++){
		dmacman_call4(ch, 0);
		dmacman_call6(ch, 0);
		dmacman_call8(ch, 0);
	}
	dmacman_call10( 4, 0);
	dmacman_call10( 9, 0);
	dmacman_call12( 4, 0);
	dmacman_call12( 9, 0);
	dmacman_call12(10, 0);
	dmacman_call26_setBF801578(1);

	CpuResumeIntr(x);					//intrman
	return 0;
}

///////////////////////////////////////////////////////////////////////
int  dmacman_call2(){
     int x;
     register int ch, value;

	CpuSuspendIntr(&x);					//intrman

	dmacman_call26_setBF801578(0);
	for (ch=0; ch<13; ch++){
		value=dmacman_call9(ch);
//		if (value & DMAch_CONTINUED)
		if ((value >> 24) & 1==1)			//sysmem
			Kprintf("WARNING:DMA %dch has been continued until shutdown\n", ch);
		dmacman_call8(ch, value & 0xFEFFFFFF);
	}

	CpuResumeIntr(x);					//intrman
	return 1;
}

///////////////////////////////////////////////////////////////////////
int  dmacman_call28(int ch, int b, int c, int d, int e){
	if (ch<13 && ch != 6){
		dmacman_call4(ch, 0x00FFFFFF & b);
		dmacman_call6(ch, (c & 0xFFFF) | (d << 16));
		dmacman_call8(ch, (e & 1) | 0x200 | ((e==0)<<30));
		return 1;
	}
	return 0;
}

///////////////////////////////////////////////////////////////////////
int  dmacman_call29(int code, int b, int c){
	if (code !=4 && code != 9)
		return 0;
	dmacman_call6(code,  b & 0x0000FFFF);
	dmacman_call8(code,      0x00000601);
	dmacman_call10(code, c & 0x00FFFFFF);
	return 1;
}

///////////////////////////////////////////////////////////////////////
int  dmacman_call30(int ch, int b, int c){
	if (ch != 9)
		return 0;
	dmacman_call6( 9, b & 0x0000FFFF)
	dmacman_call8( 9,     0x00000701);
	dmacman_call10(9, c & 0x00FFFFFF);
	return 1;
}

///////////////////////////////////////////////////////////////////////
int  dmacman_call31(int ch, int value){
	if (ch != 10)
		return 0;
	dmacman_call6(10, value & 0x0000FFFF);
	dmacman_call8(10,         0x40000300);
	return 1;
}

///////////////////////////////////////////////////////////////////////
void dmacman_call32_setContinued(int ch, int b){
	if (ch < 15)
		dmacman_call8(ch, DMAch_CONTINUED | dmacman_call9(ch, b));
}

///////////////////////////////////////////////////////////////////////
// set 7-bit value
void dmacman_call33(int code, int value){
     int x;
	CpuSuspendIntr(&x);					//intrman

	switch (code){
	case  0: dmacman_call14_setBF8010F0(
		(dmacman_call15_getBF8010F0() & 0xFFFFFFF8) |
		(        value                &          7));		break;
	case  1: dmacman_call14_setBF8010F0(
		(dmacman_call15_getBF8010F0() & 0xFFFFFF8F) |
		((       value                &          7) <<  4));	break;
	case  2: dmacman_call14_setBF8010F0(
		(dmacman_call15_getBF8010F0() & 0xFFFFF8FF) |
		((       value                &          7) <<  8));	break;
	case  3: dmacman_call14_setBF8010F0(
		(dmacman_call15_getBF8010F0() & 0xFFFF8FFF) |
		((       value                &          7) << 12));	break;
	case  4: dmacman_call14_setBF8010F0(
		(dmacman_call15_getBF8010F0() & 0xFFF8FFFF) |
		((       value                &          7) << 16));	break;
	case  5: dmacman_call14_setBF8010F0(
		(dmacman_call15_getBF8010F0() & 0xFF8FFFFF) |
		((       value                &          7) << 20));	break;
	case  6: dmacman_call14_setBF8010F0(
		(dmacman_call15_getBF8010F0() & 0xF8FFFFFF) |
		((       value                &          7) << 24));	break;
	case  7: dmacman_call16_setBF801570(
		(dmacman_call17_getBF801570() & 0xFFFFFFF8) |
		(        value                &          7));		break;
	case  8: dmacman_call16_setBF801570(
		(dmacman_call17_getBF801570() & 0xFFFFFF8F) |
		((       value                &          7) <<  4));	break;
	case  9: dmacman_call16_setBF801570(
		(dmacman_call17_getBF801570() & 0xFFFFF8FF) |
		((       value                &          7) <<  8));	break;
	case 10: dmacman_call16_setBF801570(
		(dmacman_call17_getBF801570() & 0xFFFF8FFF) |
		((       value                &          7) << 12));	break;
	case 11: dmacman_call16_setBF801570(
		(dmacman_call17_getBF801570() & 0xFFF8FFFF) |
		((       value                &          7) << 16));	break;
	case 12: dmacman_call16_setBF801570(
		(dmacman_call17_getBF801570() & 0xFF8FFFFF) |
		((       value                &          7) << 20));	break;
	case 13: dmacman_call18_setBF8015F0(
		(dmacman_call19_getBF8015F0() & 0xFFFFFFF8) |
		(        value                &          7));		break;
	case 14: dmacman_call18_setBF8015F0(
		(dmacman_call19_getBF8015F0() & 0xFFFFFF8F) |
		((       value                &          7) <<  4));	break;
	case 15: dmacman_call18_setBF8015F0(
		(dmacman_call19_getBF8015F0() & 0xFFFFF8FF) |
		((       value                &          7) <<  8));	break;
	case 67: dmacman_call14_setBF8010F0(
		(dmacman_call15_getBF8010F0() & 0x8FFFFFFF) |
		((       value                &          7) << 28));	break;
	case 85: dmacman_call16_setBF801570(
		(dmacman_call17_getBF801570() & 0xF8FFFFFF) |
		((       value                &          7) << 24));	break;
	}

	CpuResumeIntr(x);					//intrman
}

///////////////////////////////////////////////////////////////////////
// set 8th bit
void dmacman_call34(int code){
     int x;
	CpuSuspendIntr(&x);					//intrman

	switch (code){
	case  0: dmacman_call14_setBF8010F0(
		(dmacman_call15_getBF8010F0() | 0x00000008));	break;
	case  1: dmacman_call14_setBF8010F0(
		(dmacman_call15_getBF8010F0() | 0x00000080));	break;
	case  2: dmacman_call14_setBF8010F0(
		(dmacman_call15_getBF8010F0() | 0x00000800));	break;
	case  3: dmacman_call14_setBF8010F0(
		(dmacman_call15_getBF8010F0() | 0x00008000));	break;
	case  4: dmacman_call14_setBF8010F0(
		(dmacman_call15_getBF8010F0() | 0x00080000));	break;
	case  5: dmacman_call14_setBF8010F0(
		(dmacman_call15_getBF8010F0() | 0x00800000));	break;
	case  6: dmacman_call14_setBF8010F0(
		(dmacman_call15_getBF8010F0() | 0x08000000));	break;
	case  7: dmacman_call16_setBF801570(
		(dmacman_call17_getBF801570() | 0x00000008));	break;
	case  8: dmacman_call16_setBF801570(
		(dmacman_call17_getBF801570() | 0x00000080));	break;
	case  9: dmacman_call16_setBF801570(
		(dmacman_call17_getBF801570() | 0x00000800));	break;
	case 10: dmacman_call16_setBF801570(
		(dmacman_call17_getBF801570() | 0x00008000));	break;
	case 11: dmacman_call16_setBF801570(
		(dmacman_call17_getBF801570() | 0x00080000));	break;
	case 12: dmacman_call16_setBF801570(
		(dmacman_call17_getBF801570() | 0x00800000));	break;
	case 13: dmacman_call18_setBF8015F0(
		(dmacman_call19_getBF8015F0() | 0x00000008));	break;
	case 14: dmacman_call18_setBF8015F0(
		(dmacman_call19_getBF8015F0() | 0x00000080));	break;
	case 15: dmacman_call18_setBF8015F0(
		(dmacman_call19_getBF8015F0() | 0x00000800));	break;
	case 85: dmacman_call16_setBF801570(
		(dmacman_call17_getBF801570() | 0x08000000));	break;
	}

	CpuResumeIntr(x);					//intrman
}

///////////////////////////////////////////////////////////////////////
// reset 8th bit
void dmacman_call35(int code){
     int x;
	CpuSuspendIntr(&x);					//intrman

	switch (code){
	case  0: dmacman_call14_setBF8010F0(
		(dmacman_call15_getBF8010F0() & 0xFFFFFFF7));	break;
	case  1: dmacman_call14_setBF8010F0(
		(dmacman_call15_getBF8010F0() & 0xFFFFFF7F));	break;
	case  2: dmacman_call14_setBF8010F0(
		(dmacman_call15_getBF8010F0() & 0xFFFFF7FF));	break;
	case  3: dmacman_call14_setBF8010F0(
		(dmacman_call15_getBF8010F0() & 0xFFFF7FFF));	break;
	case  4: dmacman_call14_setBF8010F0(
		(dmacman_call15_getBF8010F0() & 0xFFF7FFFF));	break;
	case  5: dmacman_call14_setBF8010F0(
		(dmacman_call15_getBF8010F0() & 0xFF7FFFFF));	break;
	case  6: dmacman_call14_setBF8010F0(
		(dmacman_call15_getBF8010F0() & 0xF7FFFFFF));	break;
	case  7: dmacman_call16_setBF801570(
		(dmacman_call17_getBF801570() & 0xFFFFFFF7));	break;
	case  8: dmacman_call16_setBF801570(
		(dmacman_call17_getBF801570() & 0xFFFFFF7F));	break;
	case  9: dmacman_call16_setBF801570(
		(dmacman_call17_getBF801570() & 0xFFFFF7FF));	break;
	case 10: dmacman_call16_setBF801570(
		(dmacman_call17_getBF801570() & 0xFFFF7FFF));	break;
	case 11: dmacman_call16_setBF801570(
		(dmacman_call17_getBF801570() & 0xFFF7FFFF));	break;
	case 12: dmacman_call16_setBF801570(
		(dmacman_call17_getBF801570() & 0xFF7FFFFF));	break;
	case 13: dmacman_call18_setBF8015F0(
		(dmacman_call19_getBF8015F0() & 0xFFFFFFF7));	break;
	case 14: dmacman_call18_setBF8015F0(
		(dmacman_call19_getBF8015F0() & 0xFFFFFF7F));	break;
	case 15: dmacman_call18_setBF8015F0(
		(dmacman_call19_getBF8015F0() & 0xFFFFF7FF));	break;
	case 85: dmacman_call16_setBF801570(
		(dmacman_call17_getBF801570() & 0xF7FFFFFF));	break;
	}

	CpuResumeIntr(x);					//intrman
}

//////////////////////////////entrypoint///////////////////////////////
struct export export_stub={
	0x41C00000,
	0,
	VER(1, 2),	// 1.2 => 0x102
	0,
	"dmacman",
	(func)start,	// entrypoint
	(func)retonly,
	(func)dmacman_call2,
	(func)retonly,
	(func)dmacman_call4,
	(func)dmacman_call5,
	(func)dmacman_call6,
	(func)dmacman_call7,
	(func)dmacman_call8,
	(func)dmacman_call9,
	(func)dmacman_call10,
	(func)dmacman_call11,
	(func)dmacman_call12,
	(func)dmacman_call13,
	(func)dmacman_call14_setBF8010F0,
	(func)dmacman_call15_getBF8010F0,
	(func)dmacman_call16_setBF801570,
	(func)dmacman_call17_getBF801570,
	(func)dmacman_call18_setBF8015F0,
	(func)dmacman_call19_getBF8015F0,
	(func)dmacman_call20_setBF8010F4,
	(func)dmacman_call21_getBF8010F4,
	(func)dmacman_call22_setBF801574,
	(func)dmacman_call23_getBF801574,
	(func)dmacman_call24_setBF80157C,
	(func)dmacman_call25_getBF80157C,
	(func)dmacman_call26_setBF801578,
	(func)dmacman_call27_getBF801578,
	(func)dmacman_call28,
	(func)dmacman_call29,
	(func)dmacman_call30,
	(func)dmacman_call31,
	(func)dmacman_call32_setContinued,
	(func)dmacman_call33,
	(func)dmacman_call34,
	(func)dmacman_call35,
	0
};

void retonly(){}