//[module]	REBOOT
//[processor]	IOP
//[type]	ELF-IRX
//[size]	1985(0x7C1)
//[bios]	T10000(0x3FEF0-0x406C0)
//[iopboot]	21
//[name]	RebootByEE
//[version]	0x101
//[memory map]	BF801538(w)
//[handlers]	80000003(CMD,Reboot service module.(99/11/10))
//[entry point]	start
//[made by]	[RO]man

#include "..\include\loadcore.h"	//(0x101,FlushDcache,QueryBootMode)
#include "..\include\intrman.h"		//(0x102,CpuEnableIntr)
#include "..\include\stdio.h"		//(0x102,printf)
#include "..\include\sifman.h"		//(0x101,sceSifInit,sifman_call22,sceSifCheckInit)
#include "..\include\sifcmd.h"		//(0x101,sceSifInitCmd,sceSifAddCmdHandler)
#include "..\include\modload.h"		//(0x101,ReBootStart)
#include "..\include\thbase.h"		//(0x101,CreateThread,StartThread,GetSystemStatusFlag)
#include "..\include\thevent.h"		//(0x101,iSetEventFlag,WaitEventFlag)

struct s0{
	int SystemStatusFlag;	//+00 used r/w
	int f4;			//+04 used r
	int f8;			//+08 used w?
	int fC;			//+12
} s;
int unk20[20];	//at 0x400

int thread_entry();

//////////////////////////////entrypoint///////////////////////////////
int start(){
    struct ThreadParam	threadParam;
    register int	*v;
    register int 	thid;

	FlushDcache();						//loadcore
	if (v=QueryBootMode(3)){				//loadcore
		if (v[1] & 1){
			printf(" No SIF service(reboot)\n");	//stdio
			return 1;
		}
		if (v[1] & 2){
			printf(" No Reboot by EE service\n");	//stdio
			return 1;
		}
	}

	CpuEnableIntr();					//intrman
	threadParam.attr	=0x200;
	threadParam.entry	=thread_entry;
	threadParam.initPriority=10;
	threadParam.stackSize	=0x800;
	threadParam.option	=0;
	if ((thid=CreateThread(&threadParam))<=0)		//thbase
		return 1;
	StartThread(thid, 0);					//thbase
	return 0;
}

struct s1{
        int             f0[4];  	//+00
        int             len;    	//+16   used r  //  Ŀ
        int             f14;    	//+20   used r  //  ͻ    
        unsigned char   f18[0]; 	//+24   used r  //  ͻ  
};                                      	        //         
                                                	//         
struct s2{						//       
        int             statusFlag;	//+00   used r  //       
        int             f4;    		//+04   used w  // <ͼ 
        unsigned char   f8[0];  	//+08   used w  // <ͼ
}

///////////////////////////////////////////////////////////////////////
int reboot_cmdh_80000003(struct s1 *in, struct s2 *out){
	for (i=0; i<in.len; i++)
		out.f8[i]=in.f18[i];
	out.f4=in.f14;
	return iSetEventFlag(out.statusFlag, 0x400);		//thevent//?unk20?
}

///////////////////////////////////////////////////////////////////////
int thread_entry(){
	if (sceSifCheckInit()==0)				//sifman
		sceSifInit();					//sifman
	printf("Reboot service module.(99/11/10)\n");		//printf
	s.SystemStatusFlag=GetSystemStatusFlag();		//thbase
	sceSifInitCmd();					//sifcmd
	sceSifAddCmdHandler(0x80000003, reboot_cmdh_80000003, &s);//sifcmd
	WaitEventFlag(s.SystemStatusFlag, 0x400, 0, 0);		//thevent//?unk20?
	printf("Get Reboot Request From EE\n");			//stdio
	sifman_call22(2);					//sifman
	*(int*)(0xBF801538)=0;					//!!!!!!!!
	ReBootStart(&s.f8, s.f4);				//modload
	return 0;
}
